package characters;
import com.nttdocomo.ui.*;
import drawing.*;
import gaming.*;

public abstract class ICharacter implements IDrawingEntry{
		protected int x,y,z ,life,mind,xMove,yMove;
		protected boolean alive;
		protected long score;

		protected static final int walkSpeed=2;
		protected int hFace =1,vFace=1,animCnt=0 ;
		protected int goldCnt=0;

		protected ISprite sprite;


		public int getX(){return x;}
		public int getY(){return y;}
		public int getZ(){return z;}
		public void setX(int xx){x = xx;}
		public void setY(int yy){y = yy;}
		public void setZ(int zz){z = zz;}
		public abstract void reset();
		
		public int getBX(){return (x+Blocks.halfsize) >> Blocks.shiftsize;}
		public int getBY(){return (y+Blocks.halfsize) >> Blocks.shiftsize;}
		
		public int getLife(){return life;}
		public boolean isAlive(){return alive;}
		public long getScore(){return score;}

		public int getXMove(){return xMove;}
		public int getYMove(){return yMove;}

		public int getMind(){return mind;};

		public abstract boolean action();


		public abstract void moveTo(int xx,int yy);
		public abstract void moveBy(int xx,int yy);

		public boolean collision(ICharacter obj){
			return (getBX() == obj.getBX() && getBY() == obj.getBY());
		}
		public abstract boolean onCollided(ICharacter obj);
		public abstract boolean kill();
	
}