package drawing;

import com.nttdocomo.ui.*;


public class CanvasInfo{
	int virtualWidth  = 240;
	int virtualHeight = 240;
	int screenWidth   = 240;
	int screenHeight  = 240;
	float scaleX = 1.0f;
	float scaleY = 1.0f;
	private Canvas canvas;
	public CanvasInfo(Canvas cv){
		updateCanvas(cv);
		canvas = cv;
	}
	public void updateCanvas(Canvas cv){
		screenWidth  = cv.getWidth();
		screenHeight = cv.getHeight();
		updateScale();
	}
	private void updateScale(){
		scaleX = ((float)screenWidth )  / virtualWidth;
		scaleY = ((float)screenHeight ) / virtualHeight;
	}

	public int getVirtualWidth(){
		return virtualWidth;
	}
	public int getVirtualHeight(){
		return virtualHeight;
	}
	public void setVirtualScreenSize(int w,int h){
		if(w != virtualWidth || h != virtualHeight){
			virtualWidth  = w;
			virtualHeight = h;
			updateScale();
		}
	}

	public int getScreenWidth(){
		return screenWidth;
	}
	public int getScreenHeight(){
		return screenHeight;
	}
	public float getScaleX(){
		return scaleX;
	}
	public float getScaleY(){
		return scaleY;
	}
	
	public void setSoftLabel(int num,String str){
		if(num == canvas.SOFT_KEY_1)
			canvas.setSoftLabel(canvas.SOFT_KEY_1,str);
		else
			canvas.setSoftLabel(canvas.SOFT_KEY_2,str);
	}
} //
