package drawing;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;


/*
	kς݂̃f[^pӂ邱Ƃŏ𑬂߂悤ƎvA
	pӂȂĂ\ȑxœĂ܂̂ŎgĂȂ
*/
public class ScaledImage{
	private static Image dummy = Image.createImage(8,8);

	public int getWidth(){
		return baseImage.getWidth();
	}
	public int getHeight(){
		return baseImage.getHeight();
	}
	private Image baseImage;
	private Image scaledImage;
	public Image getBase(){
		return baseImage;
	}
	public Image getScaled(){
		return scaledImage;
	}

	public void updateScaling(CanvasInfo ci){
		if(scaledImage != null)scaledImage.dispose();
		scaledImage = VGraphics.getScaledImage(baseImage,ci);
	}
	public boolean drawingEntry(){return false;}

	private ScaledImage(){	}
	
	public void setImage(Image img,CanvasInfo ci){
		baseImage = img;
		scaledImage = VGraphics.getScaledImage(baseImage,ci);
	}

	public static ScaledImage create(Image img,CanvasInfo ci){
		ScaledImage ret = new ScaledImage();
		ret.baseImage = img;
		ret.scaledImage = dummy;//Image.createImage(16,16);//VGraphics.getScaledImage(img,ci);
		return ret;
	}
	
	public static ScaledImage create(String fileName,CanvasInfo ci){
		Image tmp;
		
		try{
			System.out.println("GET " + fileName);
			MediaImage pm = MediaManager.getImage(fileName);
			pm.use();
			tmp = pm.getImage();
		}catch(ConnectionException ce){
			System.out.println(fileName + "  "+ce.toString());
			tmp = Image.createImage(16,16);
			Graphics gg = tmp.getGraphics();
			gg.setColor(gg.getColorOfRGB(0xcc,0xcc,0xcc));
			gg.fillRect(0,0,16,16);
			gg.dispose();
		}
		return create(tmp,ci);
	}
}