package drawing;
import com.nttdocomo.ui.*;
//import java.lang.*;
public final class VGraphics{
	private CanvasInfo info;
	private Graphics g;
	private int sWidth=240,sHeight=320;
	private int scaleX = 128,scaleY = 128;
	private int[] matrix = new int[]{1,0,0,0,1,0,1,1,1};
	private ZSorter zsorter;
	public VGraphics(CanvasInfo ci){
		zsorter = new ZSorter();
		setCanvasInfo(ci);
	}

	public void setCanvasInfo(CanvasInfo ci){
		info = ci;
//		scaleX = (java.lang.Math.round(ci.getScaleX()))  <<7;
//		scaleY = (java.lang.Math.round(ci.getScaleY()))  <<7;
		scaleX = (((int)(info.getScaleX()*(1<<7) +.5)));
		scaleY = (((int)(info.getScaleY()*(1<<7) +.5)));
		sWidth = info.getScreenWidth();
		sHeight= info.getScreenHeight();
	}
	public void setGraphics(Graphics gg){
		scaleX = (((int)(info.getScaleX()*(1<<7) +.5)));
		scaleY = (((int)(info.getScaleY()*(1<<7) +.5)));
		g = gg;
	}
	
	public void setColor(int c){
		g.setColor(c);
	}
	public void setColor(int r,int g,int b){
//		g.setColor(g.getColorOfRGB(r,g,b));
	}
	public void setFont(Font f){
		g.setFont(f);
	}


	public void drawString(String str , int xx , int yy){
		g.drawString(str,  ( xx * scaleX ) >>7 , (yy * scaleY) >>7);
	}
//	public Font getFont(){
//		return Font.getDefaultFont();
//	}

	public void clearRect(int x,int y,int xx,int yy)
	{
		g.clearRect( 
				(x * scaleX)  >> 7,
				(x * scaleY)  >> 7,
				(xx * scaleX) >> 7,
				(y * scaleY)  >> 7
		);
	}
	public void clear(){
		g.clearRect( 0,0,sWidth,sHeight);
	}
	
	public void drawImage(Image image , int x , int y){
		g.drawImage(image , x * scaleX >>7 , y *scaleY >>7);
	}

	public void drawImage(ScaledImage image , int x , int y){
		g.drawImage(image.getScaled() , x * scaleX >>7 , y *scaleY >>7);
	}

	public void drawImage(Image image , int x , int y , int w , int h){
		g.drawScaledImage(image , 
				x * scaleX >>7 , y *scaleY >>7,
				w * scaleX >>7 , h *scaleY >>7,
				0,0,image.getWidth(),image.getHeight()
		);
	}

	public void drawImage(ScaledImage image , int x , int y , int w , int h){
		g.drawScaledImage(image.getBase() , 
				x * scaleX >>7 , y *scaleY >>7,
				w * scaleX >>7 , h *scaleY >>7,
				0,0,image.getWidth(),image.getHeight()
		);
	}

	public void drawLine(int x , int y , int xx , int yy){
		g.drawLine(x * scaleX >>7 , y *scaleY >>7 , xx*scaleX >>7 , yy*scaleY>>7);
	}

	public void drawRect(int x , int y , int w , int h){
		g.drawRect(x * scaleX >>7 , y *scaleY >>7 , w*scaleX >>7 , h*scaleY>>7);
	}
	public void fillRect(int x , int y , int w , int h){
		g.fillRect(x * scaleX >>7 , y *scaleY >>7 , w*scaleX >>7 , h*scaleY>>7);
	}

	
	public void setFlipMode(int mode){
		g.setFlipMode(mode);
	}
	
	public Image getScaledImage(Image image){
		return VGraphics.getScaledImage(image,info);
	}

	public static Image getScaledImage(Image image, CanvasInfo ci){
		int sx = (int)(ci.getScaleX() +.5) <<7, sy = (int)(ci.getScaleY() + .5) <<7;
		Image ret = Image.createImage(
					image.getWidth() * sx  >>7 ,
					image.getHeight() * sy >>7 
					);
		Graphics gg = ret.getGraphics();
		gg.drawScaledImage(
				image,
				0,0,
				image.getWidth()  * sx >>7 ,
				image.getHeight() * sy >>7 ,
				0,0,
				image.getWidth(),
				image.getHeight()
		);
		gg.dispose();
		return ret;
	}

	public void entry(IDrawingEntry obj){
		zsorter.entry(obj);
	}
	public void draw(){
		zsorter.draw(this);
	}
	
}