package drawing;
import com.nttdocomo.ui.*;


	public class VSprite implements ISprite , IDrawingEntry{
		protected boolean alive;
		protected int x;
		protected int y;
		protected int z;
		private int width;
		private int height;
//		private float opacity;
//		private int opa;
		protected boolean visible;
		private boolean flipV;
		private boolean flipH;
//		private CanvasInfo inf;

		private int color;

		private ScaledImage simage;


		private int id=0;
		private static int idcnt=0;
//---------------------

		public VSprite(){
			id=idcnt++;
			reset();
			alive=true;
			visible = false;
		}
		public void reset(){
			alive=false;
			x=0;y=0;z=0;
			width  = 32;
			height = 32;
			flipV=false;
			flipH=false;

//			opacity=1;

		}

//---------------------

		public int getId(){return id;}

//---------------------
		public int  getX(){return x;}
		public void setX(int xx){x=xx;}
		public int  getY(){return y;}
		public void setY(int yy){y=yy;}
		public int  getZ(){return z;}
		public void setZ(int zz){z=zz;}

		public int  getWidth(){return width;}
		public void setWidth(int ww){width=ww;}
		public int  getHeight(){return height;}
		public void setHeight(int hh){height=hh;}

//---------------------
		public void setColor(int cl){
			color=cl;
		}
		public int getColor(){
			return color;
		}
		
		public boolean isVisible(){return visible;}
		public void setVisible(boolean f){visible = f;}

		public boolean isFlipV(){return flipV;}
		public void setFlipV(boolean f){flipV = f;}
		public boolean isFlipH(){return flipH;}
		public void setFlipH(boolean f){flipH = f;}


//---------------------


		public boolean isAlive(){return alive;}
		public void setAlive(boolean f){alive = f;}

//---------------------

		public void setImage(ScaledImage img){
			simage = img;
		}

//		public void setImage(Image img,CanvasInfo inf){
//		}

		public void updateScaling(CanvasInfo ci){
			if(simage!=null){
				simage.updateScaling(ci);
			}
		}


//---------------------


		public void setSize(int ww,int hh){
			width=ww;
			height=hh;
		}

//---------------------


		public void moveTo(int xx,int yy,int zz){
			x=xx;y=yy;z=zz;
		}
		public void moveTo(int xx,int yy){
			x=xx;y=yy;
		}

//---------------------

		
		public boolean drawingEntry(VGraphics g){
			if( alive && visible ){g.entry(this);return true;}
			return false;
		}




		public boolean draw(VGraphics g){
			if(!visible)return false;

			if(simage != null){
				if(flipV || flipH){
					g.setFlipMode(
						(flipV ? Graphics.FLIP_VERTICAL   : 0) |
						(flipH ? Graphics.FLIP_HORIZONTAL : 0)
					);
					g.drawImage(simage,x,y,width,height);
					g.setFlipMode(0);
				}else{
					g.drawImage(simage,x,y,width,height);
				}
			}else{
				g.setColor(color);
				g.drawRect(x,y,width,height);
			}
			return true;
		}

		public boolean kill(){
			reset();
			return false;
		}
		
		public void dispose(){
			kill();
		}



	}

 