package drawing;
import java.lang.*;

	class ZSorter{
		private IDrawingEntry[] sortBuffer;
		private boolean sorted=false;
		 private boolean sortEnable=true;//false;//true;
		private int cnt=0;
		private int max=1024;

		public ZSorter(){
			sortBuffer = new IDrawingEntry[128*3];//SystemConfig.MaxSprites * 2];
			max = 128*3;//SystemConfig.MaxSprites * 3;
		}


		public boolean entry(IDrawingEntry s){
			if(cnt>max)return false;
			sortBuffer[cnt++] = s;
			sorted=false;
			return true;
		}

		public void sort(){
			if(!sortEnable)return;
			int i,j;
			 for(i=0;i<cnt;i++){
			  for(j=cnt-1;j>i;j--){
				if(sortBuffer[j].getZ() > sortBuffer[j-1].getZ() ){
					int jj= j-1;
					IDrawingEntry tmp = sortBuffer[j];
					sortBuffer[j]	 = sortBuffer[jj];
					sortBuffer[jj]  = tmp;
				}
			  }
			 }
			sorted=true;
		}

		public void clear(){
			for( int i= cnt - 1 ; i >= 0 ; i-- )sortBuffer[i] = null;//.clear();
			sorted=false;
			cnt=0;
		}

		public void draw(VGraphics g){
			if(cnt < 1)return;
			sort();
			for(int i=cnt-1;i>=0;i--)sortBuffer[i].draw(g);
			clear();
		}
		public void draw(VGraphics g,int from ,int to,boolean clflag){
			if(cnt < 1)return;
			int i;
			if(sortEnable){
			 if(!sorted)sort();
				for(i=cnt-1;i>=0;i--){
				  if(sortBuffer[i].getZ() > from)continue;
				  if(sortBuffer[i].getZ() < to)break;
				  sortBuffer[i].draw(g);
				}
			}else{
				for(i=cnt-1;i>=0;i--){
				  if(sortBuffer[i].getZ() > from)continue;
				  if(sortBuffer[i].getZ() < to)continue;
				  sortBuffer[i].draw(g);
				}
			}
			if(clflag)clear();
		}

	} // end class ZSorter
