package gaming;
import drawing.*;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

public final class Blocks {
	public static final int size = 16;
	public static final int halfsize = 8;
	public static final int shiftsize = 4;


//	private static String[] files;
	private static int[] colors;
	private static Image[] images;
//	private static ScaledImage brickImage;
/*
	public static String[] getFiles(){
		init();
		return files;
	}
*/
	public static int[] getColors(){
		init();
		return colors;
	}
	public static Image[] getImages(){
		init();
		return images;
	}

//	public static ScaledImage getBrickImage(){
//		return brickImage;
//	}
	
	public static void init(){
		if(colors == null){
			colors = new int[]{
						0x000000, //0
						0x00cccc, //1
						0xcccccc, //2
						0xf0f0f0, //3
						0xf0c000, //4
						0x00cc99, //5
						0xffff00, //6
						0x0000ff, //7
						0xff0000, //8
						0x00ff00  //9
				};
			String[] files = new String[]{
						"img/blank.gif",
						"img/brick.gif",
						"img/rock.gif",
						"img/ladder.gif",
						"img/rope.gif",
//						"img/hhole.gif",
						"img/brick.gif",
						"img/hladder.gif",
						"img/gold.gif",
						"img/robot.gif",
						"img/player.gif",
						"img/gate.gif"
				};
			images = new Image[files.length];
			for(int i=0;i<images.length;i++){
				try{
//					System.out.println("GET resource:///" + files[i]);
					MediaImage pm = MediaManager.getImage("resource:///" + files[i]);
					pm.use();
					images[i] = pm.getImage();
				}catch(ConnectionException ce){
					System.out.println(files[i] + " :"+ce.toString());
					images[i] = Image.createImage(size,size);
					Graphics gg = images[i].getGraphics();
					gg.setColor(colors[i]);
					gg.fillRect(0,0,size,size);
					gg.drawRect(0,0,size,size);
					gg.dispose();
				}
			}
		}
	}
	
	public static final int blank  =0;// 0000 0000
	public static final int brick  =1;// 0000 0001
	public static final int rock   =2;// 0000 0010
	public static final int ladder =3;// 0000 0011
	public static final int rope   =4;// 0000 0100
	public static final int hhole  =5;// 0000 0101
	public static final int hladder=6;// 0000 0110
	public static final int gold   =7;// 0000 0111
	public static final int enemy  =8;// 0000 1000
	public static final int player =9;// 0000 1001
	public static final int goal   =10;//0000 1010
	public static final int mblock =11;//0000 1011
	public static final int henemy =12;//0000 1100

	public static final int digger =16;//0001 0000

	// 09`12̓Q[̃}bvɂ݂͑Ȃ̂0x08enemypbitɂł
	public static final int enemybit = 0x08;
	public static final int diggerbit= 0x10;
	public static final int maskbits = (enemybit|diggerbit);


	public static final int b_blank   = 1<< 0; //    1
	public static final int b_brick   = 1<< 1; //    2
	public static final int b_rock    = 1<< 2; //    4
	public static final int b_ladder  = 1<< 3; //    8
	public static final int b_rope    = 1<< 4; //   16
	public static final int b_hhole   = 1<< 5; //   32
	public static final int b_hladder = 1<< 6; //   64
	public static final int b_gold    = 1<< 7; //  128
	public static final int b_enemy   = 1<< 8; //  256
	public static final int b_player  = 1<< 9; //  512
	public static final int b_goal    = 1<<10; // 1024
	public static final int b_mblock  = 1<<11; // 2048
	public static final int b_henemy  = 1<<12; // 4096
											   // 8192
											   //16384
											   //32768
	public static final int b_digger  = 1<<16; //65536

	public static final int b_block   = b_brick | b_rock;


	public static boolean isCeiling(int b){
		return ( (1 << (b&0x7)) & (b_block|b_hhole)) != 0;
	}
	public static boolean isFloor(int b){
		return ( (1 << (b&0x7)) & (b_block|b_ladder|b_enemy)) != 0;
	}


	public static boolean isWall(int b){
		return ( (1 << (b&0x7)) & (b_block|b_hhole)) != 0;
	}




	public static boolean isBlank(int b){
		return ( b == 0 );
	}
	public static boolean isBrick(int b){
		return ( (1 << (b&0x7)) & (b_brick)) != 0;
	}
	public static boolean isRock(int b){
		return ( (1 << (b&0x7)) & (b_rock)) != 0;
	}
	public static boolean isLadder(int b){
		return ( (1 << (b&0x7)) & (b_ladder)) != 0;
	}
	public static boolean isRope(int b){
		return ( (1 << (b&0x7)) & (b_rope)) != 0;
	}

	public static boolean isHHole(int b){
		return ( (1 << (b&0x7)) & (b_hhole)) != 0;
	}

	public static boolean isHLadder(int b){
		return ( (1 << (b&0x7)) & (b_hladder)) != 0;
	}

	public static boolean isGold(int b){
		return ( (1 << (b&0x7)) & (b_gold)) != 0;
	}

	public static boolean isEnemy(int b){
//		if( (b & Blocks.enemy) != 0)return true;
		return ( (b & enemybit) != 0);
//		return ( (1 << (b&0xf)) & (b_enemy)) != 0;
	}

	public static boolean isDigger(int b){
		return ( (b & diggerbit) != 0);
//		return ( (1 << (b&0xf)) & (b_digger)) != 0;
	}

	public static boolean isBlock(int b){
		return ( (1 << (b&0x7)) & (b_block)) != 0;
	}
	public static boolean isFloorR(int b){
		return ( (1 << (b&0x7)) & (b_block|b_ladder)) != 0;
	}
	public static boolean isFloorB(int b){
		return ( (1 << (b&0x7)) & (b_block)) != 0;
	}


	public static boolean isLadderOrRope(int b){
		return ( (1 << (b&0x7)) & (b_ladder|b_rope)) != 0;
	}
	public static boolean isAnything(int b){
		if( 
			 ( ( 1 << (b&0x7) ) &  (b_block|b_ladder|b_rope|b_gold|b_goal) )
			!= 0)return true;
		if(b>= diggerbit)return true;
		return false;
	}

	public static boolean isAnyFloor(int b){
//		var b123d= B_Block | B_Ladder| B_Digger |B_Bomber;
			// qEo[E
			//ubNE͂E@ubN̎΂ߏ
		if( b == 0 )return false;
		if( 
			 ( ( 1 << (b&0x7) ) &  (b_block|b_ladder|b_mblock) )
			!= 0)return true;
		if( (b & diggerbit) != 0)return true;
		return false;
	}
	
	public static boolean isMatch(int b,int mask){
		if( b == 0 )return false;
		if(( ( 1 << (b&0x7) ) & (mask) ) !=0)return true;
//		if( (b & mask & diggerbit) != 0)return true;
//		if( (b & mask & enemybit)  != 0)return true;
		if( ( (b & digger) !=0 ) && ( (mask & b_digger) != 0) )return true;
		if( ( (b & enemy ) !=0 ) && ( (mask & b_enemy ) != 0) )return true;
//		if( (b & mask & enemybit)  != 0)return true;
		return false;
	}


} //