package gaming;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import drawing.*;
import characters.*;


public class Digger extends ICharacter{
	protected static ScaledImage image,eimage;
	protected static int idCnt=0;

	protected ISprite sprite;
	protected ISprite effect;

	protected ICharacter master;
	protected GameStage stage;
	protected boolean busy;
		public boolean isBusy(){return busy;}

	protected int timeCntStart = 300;
	protected int timeCnt = timeCntStart;
	protected int busyTime = 14;
	protected int height;
	protected int id = idCnt++;

	public Digger(GameStage stg,CanvasInfo inf){
		stage = stg;
		mind = Blocks.digger;
		initImage(inf);
		reset();
	}
	private void initImage(CanvasInfo inf){
		if(image == null){
			image  = ScaledImage.create((Blocks.getImages())[Blocks.brick],inf);
			eimage = ScaledImage.create("resource:///img/fireball.gif",inf);
		}
	}

	public void call(int bx,int by,GameStage stg,CanvasInfo inf,ICharacter mst){
		reset();
		master = mst;
		busy   = true;
		alive  = true;
		moveTo(bx * Blocks.size,by* Blocks.size);
//		int bx = getBX(), by = getBY();
		effect.setVisible(true);
	}
	
	
	public void reset(){
		if(sprite == null){
			sprite = SpriteFactory.getSprite();
			effect = SpriteFactory.getSprite();
		}
		sprite.setImage(image);
		sprite.setSize(Blocks.size,Blocks.size);
		sprite.setZ(90);
		effect.setImage(eimage);
		effect.setSize(Blocks.size,Blocks.size);
		effect.setZ(91);
		height= Blocks.size;
		busy  = false;
		alive = false;
		timeCnt = timeCntStart;
	}
	

	public boolean action(){
		int bx = getBX(),by = getBY();
//		if(id==0)System.out.println(bx + " , " + by + " " + timeCnt + " " + busy);
		  if( timeCnt > timeCntStart - busyTime ){
			if(height>0)height -= 1;//= (timeCntStart - timeCnt) * (height / busyTime);
			int ob = stage.getXYBlock(bx,by-1);
//				stage.setXYBlock(  Blocks.brick + Blocks.digger,bx , by);
				stage.setDiggerMask( bx , by);
			if(Blocks.isEnemy(ob)){
				 kill();
			}
		  }else
		  if( timeCnt >  64 ){
			height = 0;
			if( timeCnt == timeCntStart - busyTime ){
				stage.setXYBlock(  Blocks.blank,bx , by);
				stage.setDiggerMask( bx , by);
				effect.setVisible(false);
				busy = false;
			}
		  }else{
			if(height < Blocks.size && timeCnt % 4==0)height++;
		  }
			if( timeCnt == 0 )kill();
		timeCnt--;
		return true;
	}
	public boolean drawingEntry(VGraphics g){
		int sx = stage.getScrollLeft() , sy = stage.getScrollTop();
		if( height >= 4 ){
			sprite.setSize(Blocks.size , height);
			sprite.setVisible(true);
			sprite.moveTo(x -sx,y + (Blocks.size - height) -sy);
			sprite.drawingEntry(g);
		}
			effect.moveTo(x -sx,y- Blocks.halfsize + (Blocks.size - height) -sy);
			effect.drawingEntry(g);
		return true;
	}

	public boolean draw(VGraphics g){
		return true;
	}


	public int getGold(){
		return 0;
	}



	public void moveTo(int xx,int yy){x=xx;y=yy;}
	public void moveBy(int xx,int yy){moveTo(x + xx,y + yy);}

	public boolean collision(ICharacter obj){
//	System.out.println("  "+ obj.getMind());
		if(timeCnt >0)return false;
		else return super.collision(obj);
	}


	public boolean onCollided(ICharacter obj){
		boolean ret=false;
		switch(obj.getMind()){
			case Blocks.enemy:
			case Blocks.player:
			 ret = true;
			break;
		}
		return ret;
	}

	public boolean kill(){
		if(alive){
			stage.resetDiggerMask( getBX() , getBY() );
			stage.setXYBlock( Blocks.brick, getBX() , getBY() );
		}
		timeCnt =1;
		alive=false;
		busy = false;
		return true;
	}

}