package gaming;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import drawing.*;
import characters.*;
import input.*;

public class Enemy extends ICharacter{
		protected static ScaledImage gImage;


		protected boolean deadFlag,fallFlag,ropeFlag,ladderFlag;
		protected ICharacter target;
		protected GameStage stage;
		

		protected static int idcnt=0;
		protected int id= idcnt++;
		public static int getCount(){return idcnt;}
		private ISprite gSprite;

		protected int actionCnt=0,animCnt=0,sleepCnt=0,moveCnt=0,resurrectCnt=0;
		protected int goldReleaseCnt,goldRelease=28;

		protected int sleepCntStart = 40 ,buru=0;

		protected CheckPoint checkPointA,checkPointB;

		public Enemy(GameStage stg,CanvasInfo inf){
			stage = stg;
			RobotImages.init(inf);
			if(gImage == null)
				gImage  = ScaledImage.create((Blocks.getImages())[Blocks.gold],inf);
			mind = Blocks.enemy;
			checkPointA = new CheckPointA(this);
			checkPointB = new CheckPointB(this);
			reset();
		}
		public void setTarget(ICharacter obj){
			target = obj;
		}

		public void reset(){
			if(sprite == null){
				sprite = SpriteFactory.getSprite();
				gSprite= SpriteFactory.getSprite();
			}
				deadFlag = false;
				ropeFlag = false;
				ladderFlag = false;
				fallFlag = false;
				x=0;y=0;z=95;
				hFace=1;
				goldCnt=0;
				sleepCnt=0;
				actionCnt=0;
				resurrectCnt=0;
				moveCnt=0;
				sleepCnt = -0xff;
				buru=0;
				hFace = ((id%2)==0) ? 1:-1;
				animCnt = id;
				alive=true;

				sprite.reset();
				((VSprite)sprite).setColor(0x00ffff);
				sprite.setAlive(true);
				sprite.setVisible(true);
				sprite.moveTo(x,y);
				sprite.setSize(Blocks.size , Blocks.size + Blocks.halfsize);
				sprite.setImage(RobotImages.get(RobotImages.m_stand,animCnt));
				sprite.setZ(z);

				gSprite.setAlive(true);
				gSprite.setVisible(true);
				gSprite.setImage(gImage);
				gSprite.setZ(z-1);

		}

		public boolean action(){
			stage.resetEnemyMask(getBX(),getBY());
			if(id == 0)updateActionTable();
			 int sp = checkActionTable();

			if(resurrectCnt-->0)resurrectAction();
			else{
			 if(sp>0){
				actionCnt++;
				for(int i=0;i<sp;i++){
					if(sleepCnt-- > 0)sleepAction();
					else			walkAction();
				}
			 }
			}
			stage.setEnemyMask(getBX(),getBY());
			return true;
		}

		protected boolean walkAction(){
			int bSize = Blocks.size;
			int bx = getBX() , by = getBY();
			int cb = stage.getXYBlock( bx , by );
			int hw = Blocks.halfsize, hh =Blocks.halfsize;
			int fb  = stage.getXYPointBlock(x + hw, y + bSize);
			int fbb = stage.getXYPointBlock(x + hw, y + bSize-1);
			int ctx = x + hw;
			int xs = x % bSize , ys = y % bSize;

			ropeFlag = false;
			if( Blocks.isLadder(cb) || Blocks.isLadder(fbb) )fallFlag = false;
			else if(Blocks.isRope(cb)){

				if(ys <= (Blocks.halfsize-walkSpeed))fallFlag=false;
				else 
				if(Blocks.isLadder(fb))fallFlag=false;
				else fallFlag=true;

			}
			if( ys == 0 && !Blocks.isRope(cb))fallFlag=false;
			if(fallFlag && ys != 0){
			}else{ // s͈͌
				int xsMove = 0 , ysMove=0;
				int pbx = target.getBX() , pby = target.getBY();

				checkPointA.reset(bx , by , pbx , pby);
				checkPointB.reset(bx , by , pbx , pby);

				// vC[ƓɂĒnȂAi
				if( checkFloorLine( bx , by , pbx , pby ) )
					xsMove = ( target.getX() > x ) ? 1 : -1 ;
				else
					checkHorizontal( bx , by , pbx , pby );	// s͈͂T



				if(checkPointA.found) // ɍs
					{xsMove = checkPointA.xMove; ysMove = checkPointA.yMove;}
				else
				if(checkPointB.found) // ɍsȂ
					{xsMove = checkPointB.xMove; ysMove = checkPointB.yMove;}

					xMove = xsMove * walkSpeed;
					yMove = ysMove * walkSpeed;
			}

				// 
				fallFlag = false;
				if( !Blocks.isMatch(
								stage.getXYPointBlock(ctx, y + bSize),
//								stage.getXYBlock(bx, by + 1),
								Blocks.b_block|Blocks.b_ladder|Blocks.b_enemy
					) 
				){
//					int	cbb = stage.getXYPointBlock( bx , by );
					int	cbb = stage.getXYPointBlock( x + hw , y + hw );
				  if( !Blocks.isLadderOrRope(cbb) && 
					 sleepCnt < 0 ){ // ɗȂ悤ɂ邽
						yMove = walkSpeed;
						fallFlag = true;
				  }
				}



	// ǏՓ˔
			int xv = 1 ,yv = 1;
				if(xMove != 0){ //Փ
					int xb = stage.getXYPointBlock(x + ((xMove>0)?bSize:-1) , y+hw);
					if( Blocks.isWall(xb) || Blocks.isEnemy(xb))xv = 0;
//					if( Blocks.isMatch(xb,
//							Blocks.b_block|Blocks.b_enemy|Blocks.b_hhole))xv = 0;
				}
				if(yMove != 0){ //cՓ
					int yb=stage.getXYPointBlock(x + hw , y + ((yMove>0)?bSize:-1));
					if( yMove >= 0 && Blocks.isHHole(yb) ) yb = yb & Blocks.maskbits;
					if( Blocks.isMatch(yb,Blocks.b_block|Blocks.b_enemy|Blocks.b_hhole)){
						yv = 0;
						fallFlag = false;
					}
					xv = 0;
				}
			xMove *= xv;
			yMove *= yv;


	// ̌EړtO
			if(xMove!=0)hFace = (xMove > 0) ? 1 : -1;
			boolean mv = ( xMove != 0 || yMove != 0 );
	
	//擾
			if( xs == 0 && ys == 0){
				if(goldCnt<1 && Blocks.isGold(cb)){
					goldCnt++;
					stage.getGold(bx,by,false);
						goldReleaseCnt = stage.rnd() % goldRelease;
						//moveCnt % goldRelease;
						if(goldReleaseCnt<1)goldReleaseCnt=1;
					moveCnt=0;
				}
			}


	//ʒu␳&ړ
			int xsv=0,ysv=0;
			x+=xMove;y+=yMove;
			 if(yMove *yv != 0 && xs != 0)xsv = walkSpeed * (( xs >= hw ) ? 1 : -1);
			 if(xMove *xv != 0 && ys != 0)ysv = walkSpeed * (( ys >= hw ) ? 1 : -1);
			x+=xsv;y+=ysv;
			moveTo(x,y);

	//1()
			if(!fallFlag){
			 int mbx=getBX(),mby=getBY();
			 if( goldCnt > 0 && (bx!=mbx || by != mby)){
				moveCnt++;
				if(moveCnt > goldReleaseCnt){
					if(
						Blocks.isBlank(cb) && //|| Blocks.isHLadder(cb)) && 
						Blocks.isMatch(fb,Blocks.b_block|Blocks.b_ladder|Blocks.b_enemy) ){
						stage.setGold(bx,by);
						goldCnt--;
						goldReleaseCnt= goldReleaseCnt % goldRelease;
					}
				}
			 }
			}
	//2()
			if(fallFlag){
			  if(Blocks.isDigger(stage.getXYBlock(getBX(),getBY()))){
//				System.out.println("Digger!"+ (y%bSize));
				if(y % bSize == Blocks.halfsize){releaseGold();}
				if(y % bSize == 0){sleep();return true;}
			  }
			}
	// OtBbNύX
			if( Blocks.isRope(cb) && xv != 0) ropeFlag = true;
			if( y % bSize != 0 && Blocks.isRope(cb))
							{ropeFlag = false;fallFlag = true;}
			if( Blocks.isLadder(cb) || Blocks.isLadder(fb) )
							{ ladderFlag = true;fallFlag=false;}

			if( xMove * xv != 0){ladderFlag = false;}
			if(!ladderFlag && yMove * yv > 0){fallFlag = true;}
		 if(mv){
			animCnt++;
			ScaledImage img;
			if(fallFlag)		img = RobotImages.get(RobotImages.m_fall,animCnt);
			else if(ropeFlag)	img = RobotImages.get(RobotImages.m_rope,animCnt);
			else if(ladderFlag)	img = RobotImages.get(RobotImages.m_ladder,animCnt);
			else				img = RobotImages.get(RobotImages.m_stand,animCnt);
			sprite.setImage(img);
		 }

			return true;
		}


		public boolean sleepAction(){
			int bx = getBX(),by=getBY();
			if(sleepCnt<=8){
				buru=0;
				 int hb = stage.getXYBlock(bx , by - 1);
				 int cb = stage.getXYBlock(bx , by);// , be=B_Block|B_Enemy;
				 animCnt++;
				 sprite.setImage(RobotImages.get(RobotImages.m_fall,animCnt));
					if(Blocks.isDigger(cb) && sleepCnt>0){
					 if(Blocks.isBlock(hb) || Blocks.isEnemy(hb)){sleepCnt++;}
					 else	 y -= walkSpeed ;
					}else{
						walkAction();
						if(x % Blocks.size==Blocks.halfsize)sleepCnt++;
					}
			}else
			if(sleepCnt <  0xD){
				 sprite.setImage(RobotImages.get(RobotImages.m_fall,animCnt));
				 buru = (sleepCnt % 2 ==0) ? 2:-2;
			}
			return true;
		}



		public boolean drawingEntry(VGraphics g){
			int sx = stage.getScrollLeft() , sy = stage.getScrollTop();
			sprite.setFlipH( hFace < 0 );
			sprite.moveTo(x - sx + buru,y-Blocks.halfsize - sy);
			sprite.drawingEntry(g);
			if(goldCnt > 0){
				gSprite.setSize(Blocks.size,Blocks.size);
				gSprite.moveTo(x-sx , y - sy - Blocks.halfsize);
				gSprite.drawingEntry(g);
			}
			return true;
		}

		public boolean draw(VGraphics g){return true;}


		public int getGold(){
			goldCnt+=stage.getGold(getBX(),getBY(),false);
			return 1;
		}
		protected void setGold(){
			if( !stage.setGold( getBX() , getBY() ) )
				stage.loseGold( getBX() , getBY() );
		}
		public void moveTo(int xx,int yy){x=xx;y=yy;}
		public void moveBy(int xx,int yy){moveTo(x + xx,y + yy);}


		protected boolean checkFloorLine(int x1,int y1,int x2,int y2){
							 // ƒnǂ`FbN
			if(y1!=y2 || x2<0)return false;
			int xx1,xx2,yf=y1+1;
			int b34 = Blocks.b_ladder|Blocks.b_rope;
			int b12347abd=	Blocks.b_block | Blocks.b_ladder | Blocks.b_rope |
							Blocks.b_gold  | Blocks.b_digger;
			if(x1<=x2){xx1=x1 + 1;xx2=x2;}else{xx1 = x2 ; xx2 = x1 -1;}
			for(int i = xx1 ; i <= xx2 ; i++){
				int fb = stage.getXYBlock(i , yf);
				if( !Blocks.isMatch(fb,b12347abd) ){
					 int cb = stage.getXYBlock(i,y1);
					if(!Blocks.isLadderOrRope(cb))return false;
				}
			}
			return true;
		}
		protected void checkHorizontal(int x1,int y1,int x2,int y2){ // Ẽ`FbN
				checkH(x1,y1,x2,y2,0); //
				if(checkPointA.found)return;
				checkH(x1-1,y1,x2,y2,-1);//
				checkH(x1+1,y1,x2,y2, 1);//E
		}

		protected void checkH(int x1,int y1,int x2,int y2,int lr){
			int j = x1,max = (lr > 0) ? stage.getCols() : 0;
			int cb,fb;
			int wall = Blocks.b_block | Blocks.b_hhole;
			int floor= Blocks.b_block | Blocks.b_digger;

				for( ; ; j+=lr ){ if( j == max )break;
				if(checkPointA.found){if(Math.abs(j-x1) > checkPointA.xDistance)return;}

					cb = stage.getXYBlockR( j , y1 );// & ~Blocks.maskbits;
					if( Blocks.isMatch(cb,wall) )break;
					fb = stage.getXYBlockR( j , y1 + 1 );// & ~Blocks.maskbits;

						if( Blocks.isLadder(cb) || Blocks.isLadder(fb) ) // cE`FbN
							checkVertical( j , y1 , x2 , y2 );
						else
						if( !Blocks.isMatch(fb,floor) ){ // ubNȊO
							checkVertical( j , y1 , x2 , y2 );
							if( !Blocks.isLadderOrRope(cb) )break;
						}
					if(lr==0)break;
				}
				return;
		}


		protected void checkVertical(int x1 ,int y1 ,int x2 ,int y2 ){ // cẼ`FbN
			int i , cb = stage.getXYBlockR( x1 , y1 );
			int l = x1-1 , r = x1+1;
	/*
	E͂̒
	EɃo[Ai[荂ʒuɂn_
	E΂߉ɂ͂KRN@KAi[荂ʒuɂn_
	*/
			if( Blocks.isLadder(cb) ){
				int e = (checkPointA.found) ? y2 : 0;
				int b123= Blocks.b_block|Blocks.b_ladder|Blocks.b_digger;
				 for( i = y1-1 ; i >= e ; i-- ){ //㎋E

					cb = stage.getXYBlockR( x1 , i );
						// ݂̃ubN͂ȊO(͂̍ŏi)Ȃusꏊv
						if( !Blocks.isLadder(cb) || i==0 ){
							 ((i==y2)?checkPointA:checkPointB).compare( x1 , i );
							break;
						}
					if(checkPointA.found){if(i != y2)continue;}
					if(i < y2){
						int lb = stage.getXYBlockR(l,i);
						int rb = stage.getXYBlockR(r,i);
						// Ƀo[Ȃusꏊv
						if( Blocks.isRope(lb) || Blocks.isRope(rb)){
							 ((i==y2)?checkPointA:checkPointB).compare( x1 , i );
							continue;
						}
						// ΂߉ɏ(ubNE͂)Ȃusꏊv
						int flb = stage.getXYBlockR(l,i+1);
						int frb = stage.getXYBlockR(r,i+1);
//						if( Blocks.isFloorR(flb) || Blocks.isFloorR(frb) ||
//							Blocks.isDigger(flb | frb) )
						if( Blocks.isMatch(flb,b123) || Blocks.isMatch(frb,b123) )
							 ((i==y2)?checkPointA:checkPointB).compare( x1 , i );
					}
				 }
			} //

		int t=stage.getXYBlockR( x1 , y1 + 1 );
		if( Blocks.isMatch(
				stage.getXYBlockR( x1 , y1 + 1 ),
				Blocks.b_block|Blocks.b_digger ) 
		)return;

		int rw = (checkPointA.found) ? (y2+1) : stage.getRows()+2;

		int b12d = Blocks.b_block | Blocks.b_digger;
		int b345d= Blocks.b_ladder| Blocks.b_rope  | Blocks.b_digger;
		int b123d= Blocks.b_block | Blocks.b_ladder| Blocks.b_digger;
			for( i = y1 ; i < rw ; i ++ ){ //E
					// (ubNE@ubN)Ȃusꏊv
					int fb = stage.getXYBlockR( x1 , i + 1 );
					if( Blocks.isMatch(fb , b12d) ){
						 ((i==y2)?checkPointA:checkPointB).compare( x1 , i );
						break;
					}else
					if(i >= y2){// vC[Ɠ
						cb = stage.getXYBlockR( x1 , i );
						 if( Blocks.isMatch(cb,b345d) ){
							// qEo[E
							//ubNE͂E@ubN̎΂ߏ
							int flb = stage.getXYBlockR(l,i+1);
							int frb = stage.getXYBlockR(r,i+1);
							 if( Blocks.isMatch(flb,b123d) || 
								 Blocks.isMatch(frb,b123d) ){
								((i==y2)?checkPointA:checkPointB).compare( x1 , i );
								continue;
							 }
							// o[̍E
							int lb = stage.getXYBlockR(l,i);
							int rb = stage.getXYBlockR(r,i);
							if( Blocks.isRope(lb) || Blocks.isRope(rb) )
								((i==y2)?checkPointA:checkPointB).compare( x1 , i );
						 }
					}

			} // end for

		} // end checkVertical



		protected void sleep(){
			sprite.setImage(RobotImages.get(RobotImages.m_die,animCnt));
			sleepCnt = sleepCntStart;
			fallFlag = false;
			moveTo(getBX() * Blocks.size , getBY() * Blocks.size);
//			releaseGold();
		}
		protected void releaseGold(){
			if(goldCnt < 1 )return;
			int bx = getBX() , by = getBY();
			int ub = stage.getXYBlock(bx , by-1) & ~Blocks.enemybit;
			 if(!Blocks.isBlank(ub)){
				System.out.println("lost gold!" +bx +  " " + by + " " + ub);
				stage.loseGold(bx,by-1);
				goldCnt--;
			 }else{
				stage.setGold(bx,by-1);
				goldCnt--;
			 }
		}


		public boolean onCollided(ICharacter obj){
			boolean ret=false;
			switch(obj.getMind()){
				case Blocks.digger:
					resurrect();
				break;
				case Blocks.player:
					if(resurrectCnt <= 0)ret = true;
				break;
			}
			return ret;
		}

		public boolean kill(){
			reset();
			alive=false;

			return true;
		}

		protected boolean resurrect(){
			int bx = getBX() , by = getBY();
			sprite.setImage(RobotImages.get(RobotImages.m_die, 0));
			stage.resetEnemyMask(bx,by);
			sprite.setVisible(false);
			sleepCnt = 0;
			resurrectCnt = 32;
			buru = 0;

			Enemy.lastActPtr=id;

				 if( goldCnt > 0 ){
					stage.loseGold(bx,by);
					goldCnt--;
				 }

			 int cols = stage.getCols() , rows = stage.getRows();
			 int r = (stage.rnd() % (cols-2)) + 1;
			 int rb = stage.getXYBlock(r,2) & ~Blocks.enemybit;
			 boolean f = false;
			 if( Blocks.isBlank(rb) || Blocks.isHLadder(rb))
				moveTo(r * Blocks.size , 2 * Blocks.size);
			 else{
				for(int xx = r+1 ; xx < cols - 1; xx++){
					int lx = stage.getXYBlock(xx,2) & ~Blocks.enemybit;
					if( Blocks.isBlank(lx) || Blocks.isHLadder(lx) ){
						moveTo(xx * Blocks.size , 2 * Blocks.size);
						f=true;
						break;
					}
				}
				if(!f){
				 for(int yy = 3; yy < rows -1 ; yy++){
					for(int xx = 1 ; xx < cols - 1; xx++){
						int lx = stage.getXYBlock(xx,yy) & ~Blocks.enemybit;
						if(Blocks.isBlank(lx) || Blocks.isHLadder(lx)){
							moveTo(xx * Blocks.size , yy * Blocks.size);
							f=true;
							break;
						}
					}
					if(f)break;
				 }
				 if(!f)moveTo(3 * Blocks.size , (rows  -1) * Blocks.size);
				}
			 }

//			System.out.println("resurrect:"+bx + "," + by + "" + getBX() + "," + getBY());
				 stage.setEnemyMask(getBX(),getBY());
			return true;
		}
		protected boolean resurrectAction(){
			int bx=getBX(),by=getBY(),cb=stage.getXYBlock(bx,by);

			if(resurrectCnt == 10 || resurrectCnt == 0)
									sprite.setVisible(true);
			else					sprite.setVisible( resurrectCnt % 4 < 2 );

			if(resurrectCnt > 10 )
				sprite.setImage(RobotImages.get(RobotImages.m_die, 0));
			else
				sprite.setImage(RobotImages.get(RobotImages.m_fall, 0));
			return true;
		}








	protected static int[] baseTable;
	protected static int[] actionTable;
	protected static int basePtr;
	protected static int lastActPtr;
	public static void initActionTable(int cnt){
		int a,b,c,n = cnt + 1 , i;
		if(n>8+cnt){n=8+cnt;}
		a = n / 3;
		b = a;c = a;

		if(n%3>=2){b++;c++;}else if(n%3>=1)c++;

		int[] bt = new int[]{a,b,c}, at=new int[a+b+c];
		for(i=0;i<cnt;i++)at[i]=0;
		baseTable = bt;
		actionTable=at;
		basePtr= 0;
		lastActPtr=-1;
	}


	protected static void updateActionTable(){
		int[] at = actionTable, bt = baseTable;
		int  mv=bt[basePtr % bt.length];
		int lp=0;
		lastActPtr++;
		for(int i=0;i<mv;i++){
			lp = (lastActPtr + i) % at.length;
			at[ lp ]++;
		}
		if(at.length==1)at[0]=mv;
//		for(int i=0;i<at.length; i++)System.out.print("," + at[i]);
//		System.out.println("");

		actionTable = at;
		lastActPtr=lp;
		basePtr++;
	}

	protected int checkActionTable(){
		int ret = actionTable[id];
		actionTable[id]=0;
		return ret;
	}

}









class RobotImages{
	public static final int m_stand =0;
	public static final int m_ladder=1;
	public static final int m_rope  =2;
	public static final int m_fall  =3;
	public static final int m_die   =4;

	private static ScaledImage[] stand;
	private static ScaledImage[] rope;
	private static ScaledImage[] ladder;
	private static ScaledImage[] fall;

	private static ScaledImage[] die;

	private static ScaledImage[][] table;

	public static boolean init(CanvasInfo ci){
		if(stand!=null)return true;
		stand =  new ScaledImage[]{
			ScaledImage.create("resource:///img/rbStandMove0.gif",ci),
			ScaledImage.create("resource:///img/rbStandMove1.gif",ci),
			ScaledImage.create("resource:///img/rbStandMove2.gif",ci),
			ScaledImage.create("resource:///img/rbStandMove1.gif",ci)
		};

		ladder =  new ScaledImage[]{
			ScaledImage.create("resource:///img/rbLadderMove0.gif",ci),
			ScaledImage.create("resource:///img/rbLadderMove1.gif",ci),
			ScaledImage.create("resource:///img/rbLadderMove2.gif",ci),
			ScaledImage.create("resource:///img/rbLadderMove1.gif",ci)
		};

		rope =  new ScaledImage[]{
			ScaledImage.create("resource:///img/rbRopeMove0.gif",ci),
			ScaledImage.create("resource:///img/rbRopeMove1.gif",ci),
			ScaledImage.create("resource:///img/rbRopeMove0.gif",ci),
			ScaledImage.create("resource:///img/rbRopeMove1.gif",ci)
		};

		fall =  new ScaledImage[]{
			ScaledImage.create("resource:///img/rbFall0.gif",ci),
			ScaledImage.create("resource:///img/rbFall1.gif",ci)
		};
		die =  new ScaledImage[]{
			ScaledImage.create("resource:///img/rbDie0.gif",ci)
		};

		table = new ScaledImage[][]{stand,ladder,rope,fall,die};


		return true;
	}
	
	public static ScaledImage get(int mode,int animCnt){
		ScaledImage[] tmp = table[mode];
		return tmp[(animCnt >> 1) % tmp.length];
	}



}

abstract class CheckPoint{
	
	public int x=0;
	public int y=0;
	public int xMove=0;
	public int yMove=0;
	public int xDistance=0x7fff;
	public int yDistance=0x7fff;
	boolean found = false;
	public boolean isFound(){return found;}
	public int bx = 0;
	public int by = 0;
	public int pbx = 0;
	public int pby = 0;
	ICharacter master;

	public CheckPoint(ICharacter obj){
		master = obj;
		bx = obj.getBX();
		by = obj.getBY();
	}

	public void reset(int bxx,int byy,int pbxx,int pbyy){
		x = 0x7fff; y = 0x7fff;
		xMove = 0;yMove = 0;
		xDistance = 0x7fff;yDistance = 0x7fff;
		found = false;
		bx = bxx;
		by = byy;
		pbx = pbxx;
		pby = pbyy;
	}

	public boolean overwrite(int xx ,int  yy ,int  xd ,int  yd ){
			x = xx ; y = yy;
			xDistance = xd ; yDistance = yd;
			if( xd == 0 ){
				xMove = 0;
				yMove = ( by > yy ) ? -1 : 1;
			}else{
				xMove = ( bx > xx ) ? -1 : 1;
				yMove = 0;
			}
			found = true;
			return true;
	}
	
	public abstract boolean compare(int xx ,int yy);
} //
/*
	T.reset = function(bxx,byy,pbxx,pbyy){
	 with(this){
		x = 0xffff; y = 0xffff;
		xMove = 0;yMove = 0;
		xDistance = 0xffff;yDistance = 0xffff;
		found = false;
		bx = bxx;
		by = byy;
		pbx = pbxx;
		pby = pbyy;
	 }
	}

	T.overwrite = function(xx , yy , xd , yd ){
		with(this){
			x = xx ; y = yy;
			xDistance = xd ; yDistance = yd;
			if( xd == 0 ){
				xMove = 0;
				yMove = ( by > yy ) ? -1 : 1;
			}else{
				xMove = ( bx > xx ) ? -1 : 1;
				yMove = 0;
			}
			found = true;
			return true;
		}
	}

*/
/*
i[̍ɍsꍇA
Eꂪ1Ȃ΂֌ĕB
Eꂪ2ȏ̏ꍇÁA߂ق֍sB
E2̎AIԁB
*/
class CheckPointA extends CheckPoint{ // {bgsꏊ(FC)
	public CheckPointA(ICharacter obj){
		super(obj);
	}
	public boolean compare(int xx ,int yy ){
		int xd = Math.abs( xx - bx ), yd = Math.abs( yy - by );
		if( yy != pby )return false;
		if(xDistance >= xd ){ //̏ꏊ߂
			if(xDistance != xd )
					return overwrite( xx , yy , xd , yd );
			else{ // 
				if(xx < bx) // ̃|Cg荶ɂ
					return overwrite( xx , yy , xd , yd );
			}
		}
		return false;
	}
} //
/*
function CheckPointA(obj){ // {bgsꏊ(FC)
	var T=this;
	ICheckPoint(T,obj);
	T.compare = function( xx , yy ){
	 with(this){
		var xd = Math.abs( xx - bx ), yd = Math.abs( yy - by );
		if( yy != pby )return;
		if(xDistance >= xd ){ //̏ꏊ߂
			if(xDistance != xd )
					return overwrite( xx , yy , xd , yd );
			else{ // 
				if(xx < bx) // ̃|Cg荶ɂ
					return overwrite( xx , yy , xd , yd );
			}
		}
		return false;
	 }
	}
} //

*/


/*
i[̍ɍsȂꍇA
Ei[荂ʒuɍsB
Ei[ႢʒuɂsȂꍇÂ΂񍂂Ƃ֍sB
EsɍsꏊꍇA{̐^DB
E^ȊȌ̕ꍇAɍsꏊ΂ցBȂΉEցB
*/
class CheckPointB extends CheckPoint{ // {bgsꏊɍsȂꍇɍsꏊ
	public CheckPointB(ICharacter obj){
		super(obj);
	}
	public boolean compare(int xx ,int yy ){
		int xd = Math.abs( xx - bx ), yd = Math.abs( yy - by );
			if( yy > pby ){ // vC[Ⴂ
				if( y < pby)return false;
				if(yy <= y){ //Ɠ
					if(yy < y)	return overwrite( xx , yy , xd , yd );// 
					if(xd == 0)	return overwrite( xx , yy , xd , yd );
					if(xx < x && xDistance != 0) // E荶E^ĂȂ
								return overwrite( xx , yy , xd , yd );
					return false;
				}
					return false;
			}
			else{ // vC[ʒu
				if( y > pby )return	overwrite( xx , yy , xd , yd );
				if(yy >= y){ //Ɠ
					if(yy > y)	return overwrite( xx , yy , xd , yd );// 艺
					if(xd == 0)	return overwrite( xx , yy , xd , yd );
					if(xx < x && xDistance != 0)// E荶E^ĂȂ
							 	return overwrite( xx , yy , xd , yd );
					return false;
				}
			}
		return false;
	}

} //

