package gaming;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import drawing.*;
import characters.*;
import input.*;

public class Player extends ICharacter{

//		public boolean isVisible()
//		public int getMind();
		protected static final int walkSpeed=2;
		protected int hFace =1,yFace=1,animCnt=0 ;
		protected int goldCnt=0;

		protected ISprite sprite;
//		protected Image image;

		protected boolean deadFlag,fallFlag,ropeFlag,ladderFlag;
			public boolean isDead(){return deadFlag;}
		protected ICharacter digger;
		protected GameStage stage;
		protected IGamePad gamePad;
		
		public Player(GameStage stg,CanvasInfo inf){
			stage = stg;
			PlayerImages.init(inf);
			mind = Blocks.player;
			gamePad = new VirtualGamePad();
			reset();
		}

		public void reset(){
			if(sprite == null){
				sprite = SpriteFactory.getSprite();
			}
				digger = null;
				deadFlag = false;
				ropeFlag = false;
				ladderFlag = false;
				fallFlag = false;
				x=0;y=0;z=100;
				hFace=1;yFace=1;
				goldCnt=0;
				sprite.reset();
				sprite.setAlive(true);
				sprite.setVisible(true);
				sprite.setImage(PlayerImages.get(PlayerImages.m_stand , 0,false,false));
				sprite.moveTo(x,y);
				sprite.setSize(Blocks.size , Blocks.size + Blocks.halfsize);
				sprite.setZ(z);
				
		}

		public void setPadStatus(int st){
			gamePad.setPadStatus(st);
		}

		public boolean action(){
			if(deadFlag)dyingAction();
			else	if(digger!= null)	diggerAction();
			else		 				walkAction();
			checkDamepo();
			return true;
		}
		
		protected boolean dyingAction(){
			xMove=0;
			animCnt++;
			if(yMove < 10)yMove++;
			moveBy(0,yMove);
			int bottom = (stage.getRows())* Blocks.size;
			if(y > bottom - Blocks.halfsize)y = bottom - Blocks.halfsize;
			return true;
		}
		
		protected boolean diggerAction(){
			if(!((Digger)digger).isBusy()){
				digger = null;
				return walkAction();
			}

			int bx = getBX(),by=getBY();

			animCnt++;
			ScaledImage img;
			if(deadFlag)
					img = PlayerImages.get(PlayerImages.m_die   , animCnt,false,true);
			else	if(fallFlag)
					img = PlayerImages.get(PlayerImages.m_fall  , animCnt,false,true);
			else	if(ropeFlag)
					img = PlayerImages.get(PlayerImages.m_rope  , animCnt,false,true);
			else	if(ladderFlag)
					img = PlayerImages.get(PlayerImages.m_ladder, animCnt,false,true);
			else	img = PlayerImages.get(PlayerImages.m_stand , animCnt,false,true);
				if(img!=null)sprite.setImage(img);
			return true;
		} //

		protected boolean walkAction(){
		 int xm = gamePad.getX() , ym = gamePad.getY() , dm = 0;
		 int bSize = Blocks.size , xs = x % bSize , ys = y % bSize;
		 int centerX = x + Blocks.halfsize  , centerY = y + Blocks.halfsize;
		 int bottomY = y + bSize - 1;
		 int cb = stage.getXYPointBlock(centerX , centerY );
		 int fb = stage.getXYPointBlock(centerX , y + bSize + ( ym - 1) );
		 boolean kickFlag= false;

		 fallFlag = ropeFlag = false;

		if(xm != 0){ //ړ
		  hFace = xm;
		  if(y <= 0)xm=0;
			int  xp = x + ((xm > 0) ? bSize : -1);
			int  b  = stage.getXYPointBlock( xp , centerY );
			if( Blocks.isWall(b) ){
				xm = 0;// ubN̋ڂɂ

			 if( ys == Blocks.halfsize || ys == (Blocks.halfsize+walkSpeed)){ 
				int hb = stage.getXYPointBlock( xp , y - walkSpeed*2 );
				if( !Blocks.isWall(hb) && ym < 1)ym = -1;
			 }

			}
		}
		if(!Blocks.isLadder(cb) && !Blocks.isLadder(cb) && !Blocks.isEnemy(fb))
					ladderFlag = false;
		if(ym!=0){ //cړ
			if(Blocks.isLadder(cb) || Blocks.isLadder(fb))ladderFlag = true;
			else
			if(Blocks.isEnemy(fb) && ym > 0)ladderFlag = true;
			if(xs == Blocks.halfsize && !ladderFlag){//q␳
				int lhb = stage.getXYPointBlock(centerX-walkSpeed,y-walkSpeed);
				int  lb = stage.getXYPointBlock(centerX-walkSpeed,centerY);
				if(Blocks.isLadder(lb) && xm < 1){
					xm = -1;ym=0;
				}
			}
			if(!ladderFlag && ym < 0 )ym = 0;

			int yp = y + ((ym > 0) ? bSize : -1);
			int b = stage.getXYPointBlock(centerX , yp);
			if( ym >= 0  && Blocks.isHHole(b))b = Blocks.blank;
			if( ym < 0 && Blocks.isCeiling(b))ym = 0;
			else
			if( Blocks.isWall(b) )			ym = 0;
			if(ym!=0)xm=0;
		}
		if(!ladderFlag){ //
			int ffb = stage.getXYPointBlock(centerX, y + bSize);

			if( Blocks.isLadder(cb))ladderFlag = true;
			else
			if( Blocks.isFloor(ffb) && Blocks.isRope(cb) && ym>0){
				ropeFlag=false;
			}else
			if( ym<=0 && Blocks.isRope(cb) && ys==0){
				ropeFlag = true;
//				y = (y >> Blocks.shiftsize) * bSize;
				y = getBY() * bSize;
			}else
			if(Blocks.isFloor(ffb) || Blocks.isEnemy(ffb)){
			}else{
				ym=xm=0;
				dm=1;
				fallFlag=true;
			}
		}

		// @H
		if( (gamePad.getButton(0) != 0 || gamePad.getButton(1) != 0) && dm == 0	){
			int mx = (centerX >> Blocks.shiftsize), by = getBY();
			int fx = centerX + ((gamePad.getButton(0) != 0) ? -bSize : +bSize );
			int fy = centerY + Blocks.size;
			int ffb = stage.getXYPointBlock(fx,fy);

			 if( Blocks.isBrick(ffb) ){
				int tb = stage.getXYPointBlock(fx,centerY);
				if( Blocks.isBlank(tb) || Blocks.isHLadder(tb) || Blocks.isDigger(tb) ){
					hFace = (gamePad.getButton(1) == 0) ? -1 : 1;
					digger = stage.createDigger(
							this,fx >> Blocks.shiftsize,fy >> Blocks.shiftsize);
					moveTo(mx * bSize,getBY() * bSize);
					xm=0;ym=0;
				}
			}
		}

		xMove = xm * walkSpeed;
		yMove = ym * walkSpeed + dm * walkSpeed;
		moveBy(xMove,yMove);
//*
		// ʒu␳
		if(xMove != 0 && y % bSize != 0){
			int xp = x + ((xMove>0) ? bSize :-1);
			int hp = 1 << stage.getXYPointBlock(xp,y);
			int fp = 1 << stage.getXYPointBlock(xp,y+bSize-1);
			int cmp= Blocks.b_block | Blocks.b_hhole | Blocks.b_ladder | Blocks.b_rope;
			if( ( (hp|fp) & (cmp) ) != 0 )
							y += walkSpeed*((y % bSize < Blocks.halfsize ) ? -1 : 1);
		}else
		if(yMove != 0 && x % bSize != 0)x += walkSpeed*(( x % bSize < Blocks.halfsize ) ? -1 : 1);
//*/

		if( x % bSize == 0 && y % bSize == 0 ){
			if( Blocks.isGold(cb) )getGold();
//			if( Blocks.isGate(cb) )goalGateFlag = true;
		}



		boolean mv = (xMove != 0 || yMove != 0);

		if( xMove != 0 && yMove==0){ ladderFlag = false;fallFlag=false; }

		animCnt++;

		ScaledImage img;
		if(deadFlag)
				img = PlayerImages.get(PlayerImages.m_die   , animCnt,mv,false);
		else	if(fallFlag)
				img = PlayerImages.get(PlayerImages.m_fall  , animCnt,mv,false);
		else	if(ropeFlag)
				img = PlayerImages.get(PlayerImages.m_rope  , animCnt,mv,false);
		else	if(ladderFlag)
				img = PlayerImages.get(PlayerImages.m_ladder, animCnt,mv,false);
		else	img = PlayerImages.get(PlayerImages.m_stand , animCnt,mv,false);

		if(img!=null)sprite.setImage(img);

			return true;
		}

		public boolean drawingEntry(VGraphics g){
			int sx = stage.getScrollLeft() , sy = stage.getScrollTop();
			sprite.setFlipH( hFace < 0 );
			sprite.moveTo(x -sx ,y - Blocks.halfsize - sy);
			sprite.drawingEntry(g);
			return true;
		}

		public boolean draw(VGraphics g){
			return true;
		}


		public int getGold(){
			goldCnt+=stage.getGold(getBX(),getBY(),true);
			return 1;
		}



		public void moveTo(int xx,int yy){
			x=xx;y=yy;
		}
		public void moveBy(int xx,int yy){
			moveTo(x + xx,y + yy);
		}


		public boolean onCollided(ICharacter obj){
			boolean ret=false;
			switch(obj.getMind()){
				case Blocks.digger:
				case Blocks.enemy:
					die();
					ret=false;
				break;
			}
			return ret;
		}
		
		protected void die(){
			deadFlag = true;
			yMove = -8;
			sprite.setImage(PlayerImages.get(PlayerImages.m_die ,animCnt,false,false));
		}

		public void giveup(){
			die();
		}

		public boolean kill(){
			return true;
		}
		
		private void checkDamepo(){
			int bx = getBX(),by=getBY();
			if(ladderFlag || fallFlag)return;
			int cb = stage.getXYBlock(bx     , by    );
			int lb = stage.getXYBlock(bx - 1 , by    );
			int rb = stage.getXYBlock(bx + 1 , by    );
			int db = stage.getXYBlock(bx     , by + 1);
			if(	//	Blocks.isDigger(cb) && 
					Blocks.isWall(lb) && 
					Blocks.isWall(rb) && 
					Blocks.isWall(db)
			){
				stage.zoomIn();
			}
		}

}



class PlayerImages{
	public static final int m_stand =0;
	public static final int m_ladder=1;
	public static final int m_rope  =2;
	public static final int m_fall  =3;
	public static final int m_die   =4;
	public static final int m_gate  =5;
	
	
	private static ScaledImage[] stand;
	private static ScaledImage[] standMove;
	private static ScaledImage[] standDig;
	private static ScaledImage[] rope;
	private static ScaledImage[] ropeMove;
	private static ScaledImage[] ropeDig;
	private static ScaledImage[] ladder;
	private static ScaledImage[] ladderMove;
	private static ScaledImage[] ladderDig;
	private static ScaledImage[] fall;

	private static ScaledImage[] die;
//	private static ScaledImage[] diggerEffect;

	private static ScaledImage[] gate;

	public static boolean init(CanvasInfo ci){
		if(stand!=null)return true;
		stand =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plStand0.gif",ci)
		};
		standMove = new ScaledImage[]{
			ScaledImage.create("resource:///img/plStandMove0.gif",ci),
			ScaledImage.create("resource:///img/plStandMove1.gif",ci),
			ScaledImage.create("resource:///img/plStandMove2.gif",ci),
			ScaledImage.create("resource:///img/plStandMove1.gif",ci)
		};
		standDig =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plStandDig0.gif",ci)
		};

/*
		rope =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plRope0.gif",ci)
		};
*/
		ropeMove =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plRopeMove0.gif",ci),
			ScaledImage.create("resource:///img/plRopeMove1.gif",ci),
			ScaledImage.create("resource:///img/plRopeMove2.gif",ci),
			ScaledImage.create("resource:///img/plRopeMove1.gif",ci)
		};
		ropeDig =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plRopeDig0.gif",ci),
		};
/*
		ladder =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plLadder0.gif",ci)
		};
*/
		ladderMove =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plLadderMove0.gif",ci),
			ScaledImage.create("resource:///img/plLadderMove1.gif",ci),
			ScaledImage.create("resource:///img/plLadderMove2.gif",ci),
			ScaledImage.create("resource:///img/plLadderMove1.gif",ci)
		};
		ladderDig =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plLadderDig0.gif",ci),
		};


		die =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plDie0.gif",ci)
		};
		fall =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plFall0.gif",ci)
		};

		gate =  new ScaledImage[]{
			ScaledImage.create("resource:///img/plGate0.gif",ci)
		};



		return true;
	}
	
	public static ScaledImage get(int mode,int animCnt,boolean move,boolean dig){
		ScaledImage[] tmp = null;
		switch(mode){
			default:
			case m_stand:
				tmp = (dig) ? standDig  : ((move) ? standMove  : stand );
			break;
			case m_ladder:
				tmp = (dig) ? ladderDig : ((move) ? ladderMove : ladder);
			break;
			case m_rope:
				tmp = (dig) ? ropeDig   : ((move) ? ropeMove   : rope  );
			break;
			case m_fall:
				tmp = fall;
			break;
			case m_die:
				tmp = die;
			break;
			case m_gate:
				tmp = gate;
			break;
		}
		if(tmp==null)return null;
		return tmp[(animCnt >> 2) % tmp.length];
	}



}