package gaming;
import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;
import java.util.*;
import java.io.*;
import javax.microedition.io.*;


public class SystemConfig{
	private static final String spad = "scratchpad:///0;pos=";
	public static final int SYSVER = 20070611;
	public static int frameSkip = 3;
	public static int stageCnt = 0;
	public static int lastStage = 0;
	public static int softKeyEnable = 0;
	public static int currentSysVer = SYSVER;

	public static void updateLastStage(int st){
			stageCnt = st;
			if(lastStage < stageCnt)lastStage = stageCnt;
			if(lastStage < 10)lastStage = 10;
			save();
	}
	public static void resetSysVer(){
		currentSysVer = SYSVER;
	}
	
	public static void save(){
		DataOutputStream sr = null;

		try{
			sr = Connector.openDataOutputStream(spad + "0");
				sr.writeInt(frameSkip);
				sr.writeInt(stageCnt);
				sr.writeInt(lastStage);
				sr.writeInt(softKeyEnable);
			sr.close();
		}catch(ConnectionException ce){
			System.out.println("ConnectionException:" + ce);
		}catch(IOException ie){
			System.out.println("IOException:SystemConfig.save():" + ie);
		}
		System.out.println( "SAVE\nframeSkip = " + (frameSkip - 1) + 
							" stageCnt = " + stageCnt);

	}
	public static void load(){
		DataInputStream sr = null;

		try{
			sr = Connector.openDataInputStream(spad + "0");
			frameSkip = sr.readInt();
			stageCnt  = sr.readInt();
			lastStage = sr.readInt();
			softKeyEnable = sr.readInt();
			sr.close();


		}catch(ConnectionException ce){
			System.out.println("ConnectionException:" + ce);
		}catch(IOException ie){
			System.out.println("IOException:SystemConfig.load():" + ie);
		}

			if(frameSkip > 0xff){
				stageCnt  = (frameSkip >>8) % 0xff;
				frameSkip = frameSkip &0xff;
			}
			if(frameSkip<=0)frameSkip = 3;
			updateLastStage(stageCnt);
			if(softKeyEnable == 0)softKeyEnable = 1;
	}


	public static boolean saveReplay(int num,String code,int frames){
		try{
			int fr = checkReplay(num);
			if(( fr==0 || fr > frames ) && code.length() < (2048-4-4-1)){
				System.out.println("\n\nsaveReplay:\n"+code+"\n\n"+
							spad + ( 1024 + num * 2048 ) +
							",length=2048"				
				);
			DataOutputStream sr =
					 Connector.openDataOutputStream(
							spad + ( 1024 + num * 2048 ) +
							",length=2048"
							);
				sr.writeInt(frames);
				byte[] buf = code.getBytes();
				sr.writeInt(buf.length);
				sr.write(code.getBytes());
				sr.close();
				return true;
			}
			
		}catch(ConnectionException ce){
			System.out.println("ConnectionException:" + ce);
		}catch(IOException ie){
			System.out.println("IOException:SystemConfig.load():" + ie);
		}
		return false;
	}

	public static String loadReplay(int num){
		String ret="";
		try{
		DataInputStream sr =
				 Connector.openDataInputStream(
							spad + ( 1024 + num * 2048 ) + 
							",length=2048"
							);
				System.out.println("\n\nloadReplay:\n"+
							spad + ( 1024 + num * 2048 ) +
							",length=2048"				
				);

			if(sr.readInt() >0){
				int len = sr.readInt();
				byte[] buf = new byte[len];
				for(int i=0;i<buf.length;i++)
					buf[i] = sr.readByte();
				ret = (new String(buf));
			}
		sr.close();
		}catch(ConnectionException ce){
			System.out.println("ConnectionException:loadReplay()" + ce);
		}catch(IOException ie){
			System.out.println("IOException:SystemConfig.load():" + ie);
		}
		return ret;
	}

	public static int checkReplay(int num){
		int ret = 0;
		try{
			DataInputStream sr =
				 Connector.openDataInputStream(
							spad + ( 1024 + num * 2048) +
							",length=2048"
							);
			ret = sr.readInt();
			System.out.println("ret="+ret);
			sr.close();
		}catch(ConnectionException ce){
			System.out.println("ConnectionException:" + ce);
		}catch(IOException ie){
			System.out.println("IOException:SystemConfig.load():" + ie);
		}
		return ret;
	}
}