/*
 * hello.java
 *
 */
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Panel;
import com.nttdocomo.ui.Frame;

import com.nttdocomo.ui.KeyListener;
import com.nttdocomo.ui.SoftKeyListener;
import com.nttdocomo.util.Timer;
import com.nttdocomo.util.TimerListener;


import com.nttdocomo.ui.*;

import drawing.*;
import input.*;
import gaming.*;

/**
 * hello
 *
 * @author NAME
 */
public class hello extends IApplication {

	public void start() {
		FirstPanel fp = new FirstPanel();
		fp.call();
	}



	class FirstPanel{
		public final static int w_timerID=0;
		private int timerInterval = 40;
		private ShortTimer timer;
		private BaseCanvas bc; 
		private CanvasInfo canvasInfo;
		private int frameSkip = SystemConfig.frameSkip;
		
		private IGameState gs;

		FirstPanel(){
			SystemConfig.load();
			frameSkip = SystemConfig.frameSkip;
			bc = new BaseCanvas();
			canvasInfo = new CanvasInfo(bc);
		}
		
		public void call(){
			if(gs == null)init();

			bc.call(gs);
			timer=ShortTimer.getShortTimer(bc,w_timerID,timerInterval,true);
			timer.start();
		}
		
		protected void init(){
			gs = new GameState(canvasInfo);
		}




		class BaseCanvas extends Canvas{
		private BaseCanvas bc; 
			private int actionCnt=0;

			private IGameState currentState;
			private IGameState lastState;
			private Graphics g;

			public BaseCanvas(){
				g = getGraphics();
			}

			public BaseCanvas call(IGameState state){
				currentState = state.call();
				lastState = state;
				call();
				return this;
			}

			public BaseCanvas call(){
				Display.setCurrent(this);
				return this;
			}


			public void processEvent(int w_type,int w_param) {
				if ((w_type==Display.TIMER_EXPIRED_EVENT) && (w_param==w_timerID)) {
					actionCnt++;
						currentState = currentState.action();
					if(currentState == null){
						terminate();
						return;
					}
					if(actionCnt % frameSkip == 0)draw();
				}else
				if (w_type==Display.KEY_PRESSED_EVENT){
					boolean b = currentState.onKeyPress(w_param);
					if(!b){
						if(w_param == Display.KEY_4)frameSkip++;
						else if(w_param == Display.KEY_6)frameSkip--;
						if(frameSkip<1)frameSkip=1;
						else if(frameSkip>10)frameSkip=10;
						SystemConfig.frameSkip = frameSkip;
						SystemConfig.save();
					}
				}else
				if (w_type==Display.KEY_RELEASED_EVENT){
						currentState.onKeyRelease(w_param);
				}else
				if (w_type==Display.RESUME_VM_EVENT){
						canvasInfo.updateCanvas(this);
						timer.start();
				}
			}
			public void paint(Graphics g){
			}
			public void draw(){
				lastState.draw(g);
				lastState = currentState;
			}
		} //
		
	} //

	
} //


