package input;

	public class ButtonStatus{
		private boolean pushed    = false;
		private boolean released  = false;
		private boolean changed   = false;
		private int lastValue= 0;

		 public boolean isChanged(){
			return changed;
		 }
		 public boolean isPushed(){
			return pushed;
		 }
		 public boolean isReleased(){
			return released;
		 }

		public void reset(){
			pushed   = false;
			released = false;
			changed  = false;
			lastValue= 0;
		}

		public void copyFrom(ButtonStatus st){
			pushed    = st.pushed;
			released  = st.released;
			changed   = st.changed;
			lastValue = st.lastValue;
		}

		public void setValue(boolean status){
			setValue( (status) ? 1 : 0 );
		}

		public void setValue(int status){
			status = (status>0)? 1 : 0;
			if(lastValue != status){
				changed = true;
				if(status > 0){
					pushed   = true;
					released = false;
				}else{
					pushed   = false;
					released = true;
				}
				lastValue=status;
				
			}else{
				pushed  = false;
				released= false;
				changed = false;
			}
		}

		public int getValue(){
			if(lastValue > 0)return 1;
			else	return 0;
		}
	}
